AC Challenge(状态压缩DP)

Dlsj is competing in a contest with n (0 < n \le 20)n(0<n≤20) problems. And he knows the answer of all of these problems.

However, he can submit ii-th problem if and only if he has submitted (and passed, of course) s_isi​ problems, the p_{i, 1}pi,1​-th, p_{i, 2}pi,2​-th, ......, p_{i, s_i}pi,si​​-th problem before.(0 < p_{i, j} \le n,0 < j \le s_i,0 < i \le n)(0<pi,j​≤n,0<j≤si​,0<i≤n) After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get "Accepted" of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.

"I wonder if I can leave the contest arena when the problems are too easy for me."
"No problem."
—— CCF NOI Problem set

If he submits and passes the ii-th problem on tt-th minute(or the tt-th problem he solve is problem ii), he can get t \times a_i + b_it×ai​+bi​ points. (|a_i|, |b_i| \le 10^9)(∣ai​∣,∣bi​∣≤109).

Your task is to calculate the maximum number of points he can get in the contest.

Input

The first line of input contains an integer, nn, which is the number of problems.

Then follows nn lines, the ii-th line contains s_i + 3si​+3 integers, a_i,b_i,s_i,p_1,p_2,...,p_{s_i}ai​,bi​,si​,p1​,p2​,...,psi​​as described in the description above.

Output

Output one line with one integer, the maximum number of points he can get in the contest.

Hint

In the first sample.

On the first minute, Dlsj submitted the first problem, and get 1 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2 \times 4 + 5 = 132×4+5=13 points.

On the third minute, Dlsj submitted the third problem, and get 3 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=55 points in total.

In the second sample, you should note that he doesn't have to solve all the problems.

样例输入1复制

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1复制

55

样例输入2复制

1
-100 0 0

样例输出2复制

0

题目来源

ACM-ICPC 2018 南京赛区网络预赛

题意:有n个问题,做第i个问题得分是t*a[i]+b[i](t是第几个做的题),但是做第i题之前还需要先做其他的一些题目....可以选择不做完所有的题,问最后的最高得分.

题解:一开始的思路是有依赖的树形背包问题,但是这道题还是有些诡异的,因为可以成环,所以给的不一定是一颗树,队友想到了应该是一道状压DP的问题,因为n只有20,所以状态最多1e6种,复杂度O(n*2^n),枚举所有可能的状态,并从中选择一个物品看是否这个物品需要的状态是当前枚举状态去掉这个物品状态的子集,若是,则可以进行转移。

#include<bits/stdc++.h>
#define rep(i,s,t) for(int i=s;i<=t;i++)
#define SI(i) scanf("%lld",&i)
#define PI(i) printf("%lld\n",i)
using namespace std;
typedef long long ll;
const int mod=1e9+7;
const int MAX=2e6+5;
const int INF=0x3f3f3f3f;
const double eps=1e-8;
int dir[9][2]={0,1,0,-1,1,0,-1,0, -1,-1,-1,1,1,-1,1,1};
template<class T>bool gmax(T &a,T b){return a<b?a=b,1:0;}
template<class T>bool gmin(T &a,T b){return a>b?a=b,1:0;}
template<class T>void gmod(T &a,T b){a=((a+b)%mod+mod)%mod;}
typedef pair<ll,ll> PII;

int p[30],a[30],b[30];
ll dp[MAX];
int main()
{

    int n;
    scanf("%d",&n);

    for(int i=0;i<n;i++)
    {
        int t;
        scanf("%d%d%d",&a[i],&b[i],&t);
        while(t--)
        {
            int x;
            scanf("%d",&x);
            p[i]|=(1<<x-1);
            //printf("%d\n",p[i]);
        }
    }

    for(int i=0;i<(1<<n);i++)
        dp[i]=-1e16;
    dp[0]=0;

    for(int i=0;i<(1<<n);i++)
    {
        int t=0;
        for(int j=0;j<n;j++)
            if(i&(1<<j)) t++;

        for(int j=0;j<n;j++) //枚举加入哪一个
            if(i&(1<<j) && (i&p[j])==p[j])
            {
                gmax(dp[i],dp[(1<<j)^i]+1LL*t*a[j]+b[j]);
               // printf("%d %lld\n",(1<<j)^i,dp[i]);
            }
    }

    ll ans=0;
    for(int i=0;i<(1<<n);i++)
        gmax(ans,dp[i]);

    printf("%lld\n",ans);
    return 0;
}

猜你喜欢

转载自blog.csdn.net/sudu6666/article/details/82314236
ac
今日推荐